// Copyright (c) 2000, 2002 - 2011 Citadel LLC, Confidential
// Information of Citadel LLC, or its affiliates.  All rights reserved.

#define BOOST_AUTO_TEST_MAIN
#include <boost/test/unit_test.hpp>
#include <boost/make_shared.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/archive/xml_iarchive.hpp>
#include <boost/archive/xml_oarchive.hpp>

#include "../CrashTestDLL/TestObject.H"

using namespace boost::serialization;

BOOST_AUTO_TEST_CASE(TestTestObject)
{
    // This works:
//   BaseObjectPtr baseObject(boost::make_shared<BaseObject>());
    // This fails:
    BaseObjectPtr baseObject(boost::make_shared<TestObject>());

    std::stringstream ss;
    TestObject testObject(baseObject);
    {
        boost::archive::xml_oarchive oa(ss);
        oa << boost::serialization::make_nvp("TestObject", testObject);
    }

    BOOST_TEST_MESSAGE(ss.str());

    TestObject    testObject2;
    {
        boost::archive::xml_iarchive ia(ss);
        ia >> boost::serialization::make_nvp("TestObject", testObject2);
    }

    BOOST_CHECK(true);
}
