// Copyright (c) 2000, 2002 - 2010 Citadel LLC, Confidential
// Information of Citadel LLC, or its affiliates.  All rights reserved.
// Copyright (c) 2000, 2002 - 2009 Citadel Investment Group, Confidential
// Information of Citadel Investment Group, or its affiliates.  All rights reserved.

#include "BaseObject.h"

#include <boost/serialization/nvp.hpp>
#include <boost/archive/xml_iarchive.hpp>
#include <boost/archive/xml_oarchive.hpp>

BaseObject::BaseObject()
: m_size(10)
{
}

BaseObject::~BaseObject()
{
}

template <typename Archive>
void serialize( Archive & ar, BaseObject & obj, const unsigned int /*file_version*/ )
{
    ar & boost::serialization::make_nvp( "m_size", obj.m_size );
}

template CRASHTESTDLL_API void serialize<boost::archive::xml_oarchive>( boost::archive::xml_oarchive& ar, BaseObject & obj, const unsigned int file_version );
template CRASHTESTDLL_API void serialize<boost::archive::xml_iarchive>( boost::archive::xml_iarchive& ar, BaseObject & obj, const unsigned int file_version );

BOOST_CLASS_EXPORT_IMPLEMENT(BaseObject)
