#ifndef TEST_OBJECT_H
#define TEST_OBJECT_H

#include "CrashTestDLL.h"
#include "BaseObject.H"

class TestObject;
typedef boost::shared_ptr<TestObject> TestObjectPtr;

class CRASHTESTDLL_API TestObject : public BaseObject
{
public:
    TestObject();
    TestObject(BaseObjectPtr const & object);
    virtual ~TestObject();

    template <typename Archive>
    friend void serialize( Archive & ar, TestObject & obj, const unsigned int file_version );
    friend class boost::serialization::access;

private:
    BaseObjectPtr m_object;
};

BOOST_CLASS_EXPORT_KEY2(TestObject, "TestObject")
BOOST_CLASS_TRACKING(TestObject, boost::serialization::track_always)

#endif
